(require 'gnus-diary)

(setq user-mail-address "lee@yun.yagibdah.de")
(setq user-full-name "lee")


(setq
 gnus-select-method '(nnml "yun")
 mail-sources '((maildir :path "~/DUMMY/")
		(file :path "~/Datenquellen/telephon/sms-out.mbox")
		(file :path "~/Datenquellen/telephon/sms-in.mbox")))

(setq gnus-secondary-select-methods '((nntp "news.gmane.org")))
(add-to-list 'gnus-secondary-select-methods
	     '(nntp "news1.open-news-network.org")
	     '((nndiary "diary") (nndiary-get-new-mail t)))

	     ;; '(nnimap "yun" (nnimap-stream tls)
	     ;; 	      (nnimap-address "localhost")
	     ;; 	      (nnimap-server-port 993)))


(setq gnus-parameters
      '(
	("bogus"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\.done"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\..*\\.posted"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\.sent"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\.0-incoming"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\.lists\\..*"
	 (subscribed . t)
	 (gnus-show-threads t)
	 ;;	 (gnus-thread-hide-subtree t)
	 (gnus-use-scoring  t)
	 (display . default)
	 (gcc-self . "mail.posted")
	 (posting-style (organization "my virtual residence"))
	 (gnus-summary-line-format
	  ":%U%R%z%B(%5L) %(%[%-23,23f%]%) '%s\n"))
	;;
	("mail\\.misc\\.bewerbungen"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.misc.bewerbungen")
	 (posting-style
	  (name "my name")
	  ("Return-Receipt-To" user-mail-address)
	  ("Disposition-Notification-To" user-mail-address)
	  ("X-yun.yagibdah.de-info" "ref ")
	  (body :file "~/texte/email.templates/template-00.txt"))
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail\\.per\\..*"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail.misc\\..*"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . [not expire])
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("mail.sys\\..*"
	 (gnus-show-threads nil)
	 (gnus-use-scoring nil)
	 (gnus-article-sort-functions '((not gnus-article-sort-by-date)))
	 (display . default)
	 (gcc-self . "mail.sent")
	 (gnus-summary-line-format
	  ":%U%R%z%I(%5L) %(%[%-23,23f%]%) %11&user-date; '%s\n"))
	;;
	("nntp.*"
	 (gnus-show-threads t)
	 (gnus-thread-hide-subtree t)
	 (gnus-use-scoring  t)
	 (display . default)
	 (gcc-self . "mail.news.posted")
	 (gnus-summary-line-format
	  ":%U%R%z%B(%5L) %(%[%-23,23f%]%) '%s\n")
	 (posting style (organization "my virtual residence")))
	))

;; for mailing lists:
(setq message-subscribed-address-functions
      '(gnus-find-subscribed-addresses))


;;    The `gnus-large-newsgroup' variable says what Gnus should consider
;; to be a big group.  If it is `nil', no groups are considered big.  The
;; default value is 200.  If the group has more (unread and/or ticked)
;; articles than this, Gnus will query the user before entering the group.
;; The user can then specify how many articles should be fetched from the
;; server.  If the user specifies a negative number (-N), the N oldest
;; articles will be fetched.  If it is positive, the N articles that have
;; arrived most recently will be fetched.
;;
(setq gnus-large-newsgroup 2000)


;; ,----
;; | (gnus-demon-add-handler 'gnus-demon-scan-news nil 2) ;; after 2 min idle
;; | 
;; | (gnus-demon-add-handler 'gnus-demon-scan-news 5 nil) ;; every 5 Min.
;; | 
;; | (gnus-demon-add-handler 'gnus-demon-scan-news 30 5) ;; every 30 min,
;; |                                                     ;; only when 5 min idle
;; | 
;; | (info "(gnus)Daemons")
;; `----
;; ,----
;; |    If you add handlers to `gnus-demon-handlers' directly, you should
;; | run `gnus-demon-init' to make the changes take hold.  To cancel all
;; | daemons, you can use the `gnus-demon-cancel' function.
;; `----

;; (gnus-demon-add-handler 'gnus-demon-scan-news 60 nil)
;; (gnus-demon-add-handler 'gnus-demon-scan-mail 3 t)
(gnus-demon-add-handler 'gnus-demon-close-connections nil 25)
(gnus-demon-init)

;; save msg IDs to check for duplicates

(setq nnmail-message-id-cache-length 5000)

;; ,---- (info "(gnus)Filling In Threads")
;; |      If non-`nil', Gnus will attempt to build old threads by fetching
;; |      more old headers--headers to articles marked as read.  If you would
;; |      like to display as few summary lines as possible, but still
;; |      connect as many loose threads as possible, you should set this
;; |      variable to `some' or a number.  If you set it to a number, no
;; `----

(setq gnus-fetch-old-headers "some")

;; ,----
;; |    If `gnus-use-full-window' non-`nil', Gnus will delete all other
;; | windows and occupy the entire Emacs screen by itself.  It is `t' by
;; | default.
;; `----
;; :too glitchy, use multiple frames instead
;;(setq gnus-use-full-window nil)


;; ,---- from Group Mode Line Specification
;; | `D'
;; |      Newsgroup description.  You need to read the group descriptions
;; |      before these will appear, and to do that, you either have to set
;; |      `gnus-read-active-file' or use the group buffer `M-d' command.
;; `----

(setq gnus-read-active-file "some")

;; ,---- from Group Mode Line Specification
;; |    `%M%S%5y:%B%(%g%)\n' is the default
;; `----

(setq gnus-group-line-format "%M%S%7y : %(%-65g%) (%7t) %B\n")


(setq nnmail-split-methods 'nnmail-split-fancy)
(setq nnmail-split-fancy '(|
;; [...]

			   "mail.0-incoming"))


;; gnus-summary-line-format:
;; ,----
;; |    The default string is `%U%R%z%I%(%[%4L: %-23,23f%]%) %s\n'.
;; `----
;;
;;	 (gnus-summary-line-format
;;	  "%U%R%z%I%(%[%4L: %-30,30f%]%)   %s\n")


;; nndiary settings:

(add-hook 'gnus-select-group-hook 'gnus-group-set-timestamp)
;;(setq nndiary-get-new-mail t)
(setq nndiary-mail-sources '((file :path "~/.nndiary")))
(setq nndiary-split-methods
      '(("mail.nndiary"
	 "")))
(setq nndiary-week-starts-on-monday t)


;; article caching
(setq gnus-use-cache t)

;; default archive for outgoing messages
(setq gnus-gcc-mark-as-read t)
;; (setq gnus-update-message-archive-method t)
;; (setq gnus-message-archive-group "mail.archive.all.outgoing")
;; (setq gnus-message-archive-method
;;       '(nnfolder "gnus-arc"
;; 		 (nnfolder-directory "~/Mail/archive")
;; 		 (nnfolder-active-file "~/Mail/archive/active")
;; 		 (nnfolder-get-new-mail nil)
;; 		 (nnfolder-inhibit-expiry t)))



;; scoring
(defun my-summary-mode-hook-fn ()
  (setq gnus-summary-expunge-below -1000))

(add-hook 'gnus-summary-mode-hook 'my-summary-mode-hook-fn)

;; don´t move to the next group in the group
;; buffer when exiting a group, and don´t move to unread
(setq gnus-summary-next-group-on-exit nil)
(setq gnus-group-goto-unread nil)

;; headers (for searching)
(setq gnus-extra-headers '(To Cc List-Id))
(setq nnmail-extra-headers gnus-extra-headers)

;; keep expired articles in this group
(setq nnmail-expiry-target "sys.expired")
